#include "mainwindow.h"
#include "ui_mainwindow.h"

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);

   MainWindow::readModel();

   //QString model_str;
   MainWindow::creatModelString();
   int i;
   i++;
    QFile file_tmp("./temp.txt");
    bool ok;
    ok = file_tmp.open(QIODevice::ReadWrite | QIODevice::Text);
    QTextStream out(&file_tmp);
    out << MainWindow::modelString;
    file_tmp.close();

    MainWindow::openDataBase();
    MainWindow::buildPreviewModel(tr(" "), tr("3"));

}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::changeEvent(QEvent *e)
{
    QMainWindow::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}


bool MainWindow::readModel(){
    bool result;
    QString model_str;
    QFile file(":/model.txt");

   rootItem1 = new  QTreeWidgetItem(ui->treeWidget);
    rootItem1->setText(0, tr(" 1"));
   // rootItem2 = new  QTreeWidgetItem(rootItem1);
   // rootItem2->setText(0, tr(" 2"));
    rootItem1->setCheckState(0,Qt::Checked);
   // rootItem2->setCheckState(0,Qt::Checked);



    result = file.open(QIODevice::ReadOnly);
    if (result) {
                     model_str = QString(tr(file.readAll()));
                }

    setupModelData(model_str.split(QString("\n")), rootItem1);


    return result;

}


void MainWindow::setupModelData(const QStringList &lines, QTreeWidgetItem *parent)
{
    QList<QTreeWidgetItem*> parents;
    QList<int> indentations;
    parents << parent;
    indentations << 0;

    int number = 0;

    while (number < lines.count()) {
        int position = 0;
        while (position < lines[number].length()) {
            if (lines[number].mid(position, 1) != " ")
                break;
            position++;
        }

        QString lineData = lines[number].mid(position).trimmed();

        if (!lineData.isEmpty()) {
            // Read the column data from the rest of the line.
            QStringList columnStrings = lineData.split("\t", QString::SkipEmptyParts);
            QList<QVariant> columnData;
            for (int column = 0; column < columnStrings.count(); ++column)
                columnData << columnStrings[column];

            if (position > indentations.last()) {
                // The last child of the current parent is now the new parent
                // unless the current parent has no children.

                if (parents.last()->childCount() > 0) {
                    parents << parents.last()->child(parents.last()->childCount()-1);
                    indentations << position;
                }
            } else {
                while (position < indentations.last() && parents.count() > 0) {
                    parents.pop_back();
                    indentations.pop_back();
                }
            }

            // Append a new item to the current parent's list of children.
          // // //  parents.last()->appendChild(new QTreeWidgetItem(columnData, parents.last()));
            QTreeWidgetItem* itm_tmp;
            itm_tmp = new QTreeWidgetItem( parents.last());

            itm_tmp->setText(0, QString(columnData.at(0).toString()));
            if (columnData.at(1).toString() == "true") {
                                                            itm_tmp->setCheckState(0,Qt::Checked);
                                                        }
            else itm_tmp->setCheckState(0,Qt::Unchecked);
            itm_tmp->setText(1, QString(columnData.at(2).toString()));
            itm_tmp->setText(2, QVariant(number).toString()); //    - 
            itm_tmp->setText(3, QVariant(indentations.size()).toString());
        }

        number++;
    }
}


/*
void MainWindow::openBase()
{

        db = QSqlDatabase::addDatabase("QMYSQL");
        pdb = &db;
        raportFrm.pdb = &db;

        pdb->setHostName(hostName);
        pdb->setDatabaseName(baseName);
        pdb->setUserName(userName);
        pdb->setPassword(password);
        bool ok = pdb->open();
        if (!ok) {
                                QMessageBox::critical( //     .
                                                                                this,                      //  .
                                                                                QObject::tr("Database Error"),   // .
                                                                                pdb->lastError().text());          //  .
                         }
        if (ok)
        {lineEdit-> insert(tr("  "));
        }
        else {lineEdit-> insert(tr(" .  : "));
                  lineEdit-> insert(pdb->lastError().text());
                 }



        model = new QSqlTableModel(this);
        model->setTable(tableName);

        model->setEditStrategy(QSqlTableModel::OnManualSubmit);
        model->setSort(0, Qt::AscendingOrder);

        model->select();


        QSqlField field(tr("age"), QVariant::Int);
        field.setValue(QString(tr("123")));

        bool okey;
        int index;
        QSqlRecord record;


        tableView->setModel(model);
        view.setModel(model);


        tableView->setAlternatingRowColors(true);
        view.setAlternatingRowColors(true);

        tableView->resizeColumnsToContents();


        view.resizeColumnsToContents();

        tableView->show();



        initTreeWidget();
}
*/


void MainWindow::creatModelString(){

    MainWindow::modelString.clear(); //   
 //   for (int i =0; i < rootItem1->childCount(); ++i )

    {MainWindow::addChildsString(rootItem1, 0);}

    int root_item_child_count;
    int i;
    root_item_child_count = rootItem1->childCount();
    i++;

}


void MainWindow::addChildsString(QTreeWidgetItem *parentItem, int level){
    int child_count;
    child_count = parentItem->childCount();
    for (int i=0; i < child_count; ++i){
        for (int m=0; m < level; ++m){
        modelString.append(tr("    ")); //   -  ,     
    }
        modelString.append(parentItem->child(i)->text(0)); //    -  
        modelString.append(tr("\t\t\t\t")); //   -   
        if (parentItem->child(i)->checkState(0) ==  Qt::Checked) {modelString.append(tr("true"));} //   ,  "true",      
            else {modelString.append(tr("false"));} //     -  "false",       
        modelString.append(tr("\t\t\t\t")); //   -   
        modelString.append(parentItem->child(i)->text(1)); //    - ID 
         modelString.append(tr("\n")); //  
        if (parentItem->child(i)->childCount() > 0) { MainWindow::addChildsString(parentItem->child(i), level+1);}

    }
int i;
i++;
}


bool MainWindow::openDataBase(){
    QString errorString;
    sql = QSqlDatabase::addDatabase("QMYSQL");
    sql.setDatabaseName(tr("an_db"));
    sql.setHostName(tr("localhost"));
    sql.setUserName(tr("an"));
    sql.setPassword(tr("393939"));

    bool ok;
    ok = sql.open();

    /*
    if (!ok) {
                                QMessageBox::critical( //     .
                                                                                this,                      //  .
                                                                                QObject::tr("Database Error"),   // .
                                                                                sql.lastError().text() );         //  .


                            }

*/
    if (!ok) {
                            QMessageBox::critical( //     .
                                                                            this,                      //  .
                                                                            QObject::tr("Database Error"),   // .
                                                                            sql.lastError().text());          //  .
                     }
else {

        QMessageBox::information( //     .
                                                        this,                      //  .
                                                        QObject::tr("Database Connect"),   // .
                                                        QObject::tr("     ."));         //  .





    }

     return ok;
}


bool MainWindow::buildPreviewModel(QString modelName, QString rootClassID){
QSqlQuery q;
QString sql_str;
QString field_name_str;
QString root_class_name;
bool ok;
int field_name;

//ui->treeWidget->clear();

root_class_name = MainWindow::ClassName(rootClassID); //   

rootItem1 = new  QTreeWidgetItem(ui->treeWidget);
 rootItem1->setText(0, modelName);

 rootItem1->setCheckState(0,Qt::Checked);


rootItem2 = new  QTreeWidgetItem(rootItem1);
rootItem2->setText(0, root_class_name);
rootItem2->setText(1, rootClassID);
rootItem2->setCheckState(0,Qt::Checked);



sql_str = tr("select * "
             " from DescriptionOfClasses where  DescriptionOfClasses.DefaultValue = '"       // ,     
             );
sql_str.append(rootClassID);

sql_str.append(tr("' and DescriptionOfClasses.FieldType = 'pointer' "));

q.prepare(sql_str);

ok = q.exec();
if (!ok) {
                        QMessageBox::critical( //     .
                                                                        this,                      //  .
                                                                        QObject::tr("Database Error"),   // .
                                                                        q.lastError().text());          //  .
                 }
field_name = q.record().indexOf(tr("FieldName"));
while(q.next()){

                field_name_str = q.value(field_name).toString();

                }

}



QString MainWindow::ClassName(QString class_id){ //     ID
    QSqlQuery q;
    QString sql_str;
    QString class_name_str;
    bool ok;
    int field_class_name;

    sql_str = tr("select * "
                 " from ListOfClasses where ListOfClasses.ID = '"       // ,     
                 );

    sql_str.append(class_id);
    sql_str.append(tr("' "));

    q.prepare(sql_str);

    ok = q.exec();


    if (!ok) {
                            QMessageBox::critical( //     .
                                                                            this,                      //  .
                                                                            QObject::tr("Database Error"),   // .
                                                                            q.lastError().text());          //  .
                     }

    field_class_name = q.record().indexOf(tr("ClassName"));
    while(q.next()){

                    class_name_str = q.value(field_class_name).toString();

                    }

    return class_name_str;

}
